unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, jpeg, Mandelbrot, ComCtrls;

type
  TFrameForm = class(TForm)
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    Button2: TButton;
    Mandelbrot1: TMandelbrot;
    Button1: TButton;
    Button3: TButton;
    Button13: TButton;
    Button14: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Mandelbrot1PaintedMandel(Sender: TObject; Done: Integer);
    procedure UpDown1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
  private
    { Private 錾 }
    procedure DispInfor;
  public
    { Public 錾 }
    OldStep: Extended;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.DispInfor;
var
  MMR: TRealRect;
  CCR: TRect;
  w, h: Integer;
  Digit: Integer;
begin
  Digit := DigitOf(Mandelbrot1.RulerStep);
  Digit := -Digit + 2;
  MMR := Mandelbrot1.MMRect;
  CCR := Mandelbrot1.CCRect;
  w := CCR.Right - CCR.Left + 1;
  h := CCR.Bottom - CCR.Top + 1;
  Caption := Format('MMRect = (%3.*f, %3.*f, %3.*f, %3.*f) : MStep = %.*g',
                    [Digit, MMR.Left, Digit, MMR.Top,
                     Digit, MMR.Right, Digit, MMR.Bottom, Digit, Mandelbrot1.MStep]);
  Caption := Caption + ' : ' + Mandelbrot1.STime;
  Caption := Caption + Format(' : %d ~ %d Pixels', [w, h]);
  Tag := 0;
end;

{ TMandelbrot ̃fBtHglŕ`悵܂B}

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  Mandelbrot1.MAutoSize := True;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 0.007; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-2.09, 2.1, 2.11, -2.1);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := False;
  Mandelbrot1.JCC := RealPoint(-0.159, -0.655);
  Mandelbrot1.MCount := 256;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

{ ̉摜̒Ƀ}fuW`悵܂B}

procedure TFrameForm.Button2Click(Sender: TObject);
var
  FileName: String;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'film14.jpg';
  Mandelbrot1.Picture.LoadFromFile(FileName);
  Mandelbrot1.MAutoSize := False;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 0.015; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-2.09, 2.1, 2.11, -2.1);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := False;
  Mandelbrot1.JCC := RealPoint(-0.159, -0.655);
  Mandelbrot1.MCount := 256;
  Mandelbrot1.CPoint := Point(350, 190);
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

{ }fuẄꕔg債ĕ`悵܂B}

procedure TFrameForm.Button3Click(Sender: TObject);
begin
  Mandelbrot1.MAutoSize := True;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 3.7763576E-8; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-0.7801769, 0.1499963, -0.7801543, 0.1499736);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := False;
  Mandelbrot1.JCC := RealPoint(-0.159, -0.655);
  Mandelbrot1.MCount := 256;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  Tag := -1;
end;

procedure TFrameForm.Button13Click(Sender: TObject);
begin
  Mandelbrot1.SizeOption := true;
  if Mandelbrot1.MStep < OldStep / 2 then
    Exit;
  Mandelbrot1.MStep := Mandelbrot1.MStep / Sqrt(2);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button14Click(Sender: TObject);
begin
  Mandelbrot1.SizeOption := true;
  if Mandelbrot1.MStep > OldStep * 2 then
    Exit;
  Mandelbrot1.MStep := Mandelbrot1.MStep * Sqrt(2);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button4Click(Sender: TObject);
begin
  Mandelbrot1.MAutoSize := True;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 3.86699025E-5; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-0.804493410107637, 0.173604409585091,
                                -0.781291468426539, 0.150402468192104);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := False;
  Mandelbrot1.JCC := RealPoint(-0.159, -0.655);
  Mandelbrot1.MCount := 256;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button5Click(Sender: TObject);
begin
  Mandelbrot1.MAutoSize := True;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 1.8E-10; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-0.780165612097099, 0.149985131352465,
                                -0.78016550437236, 0.149985023153106);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := False;
  Mandelbrot1.JCC := RealPoint(-0.159, -0.655);
  Mandelbrot1.MCount := 256;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.CheckBox1Click(Sender: TObject);
begin
  if Tag = -1 then
    Exit;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Mandelbrot1PaintedMandel(Sender: TObject;
  Done: Integer);
var
  S: String;
begin
  S := IntToStr(UpDown1.Position);
  if Edit1.Text <> S then
    Edit1.Text := S;

  if Done = 1 then
    DispInfor
  else
    ShowMessage('}fuW̕\Ɏs܂B');
end;

procedure TFrameForm.UpDown1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if UpDown1.Position = -1 then
    UpDown1.Position := 255
  else if UpDown1.Position = 256 then
    UpDown1.Position := 0;
end;

procedure TFrameForm.Button6Click(Sender: TObject);
begin
  Mandelbrot1.FractalInit(631, 551, 1, clGreen, clWhite); // clFuchsia
  Caption := 'vZłB΂炭҂B';

  Mandelbrot1.FractalTree(Point(120, 300), 80, Pi / 2, 0.3, 0.3, 0.7, 0.7, 12);

  Mandelbrot1.FractalTree(Point(320, 300), 80, Pi / 2, 0.1, 0.1, 0.7, 0.7, 10);

  Mandelbrot1.FractalTree(Point(500, 230), 40, Pi / 2, 0.5, 0.5, 0.8, 0.8, 12);

  Mandelbrot1.FractalTree(Point(120, 505), 60, Pi / 2, 1, 1, 0.7, 0.7, 12);

  Mandelbrot1.FractalTree(Point(320, 470), 90, Pi / 2, 2, 2, 0.7, 0.7, 12);

  Mandelbrot1.FractalTree(Point(600, 530), 55, Pi / 2, 0.4, 0.1, 0.85, 0.65, 12);


  Caption := ' 6 ނ̃tN^g[\Ă܂B: 631 ~ 551 Pixels';
end;

procedure TFrameForm.Button7Click(Sender: TObject);
begin
  Mandelbrot1.FractalInit(631, 551, 2, clFuchsia, clWhite);

  Mandelbrot1.GasketPolygon(Point(5, 230), Point(215, 230), 4);
  Mandelbrot1.Canvas.Pen.Color := clBlue;
  Mandelbrot1.Hilbert(Point(220, 41), Point(440, 41), 5);
  Mandelbrot1.Canvas.Pen.Color := clRed;
  Mandelbrot1.Peano(Point(430, 44), Point(620, 44), 3);
  Mandelbrot1.Canvas.Pen.Color := clLime;
  Mandelbrot1.KochPolygon(Point(10, 450), Point(200, 450), 3, 3);
  Mandelbrot1.Canvas.Pen.Color := clGray;
  Mandelbrot1.CarpetPolygon(Point(220, 495), Point(410, 495), 8);
  Mandelbrot1.Canvas.Pen.Color := clBlack;
  Mandelbrot1.CantorPolygon(Point(622, 315), Point(418, 315), 0, 20, 20, 8);

  Caption := 'MXPbgAqxgAyAmARbzAJ[ybgAJg[\Ă܂B: 631 ~ 551 Pixels';
end;

procedure TFrameForm.Button8Click(Sender: TObject);
begin
  Mandelbrot1.FractalInit(631, 551, 2, clGreen, clWhite);
  Caption := 'vZłB΂炭҂B';

  Mandelbrot1.Barnsley(Point(-100, 530), Point(400, 530),
                       fern[1][1], // AffineData(0, 0, 0, 0.16, 0, 0, 0.01),
                       fern[1][2], // AffineData(0.85, 0.04, -0.04, 0.85, 0, 1.60, 0.85),
                       fern[1][3], // AffineData(0.20, -0.26, 0.23, 0.22, 0, 1.60, 0.07),
                       fern[1][4], // AffineData(-0.15, 0.28, 0.26, 0.24, 0, 0.44, 0.07),
                       1,
                       200000);

  Mandelbrot1.Barnsley(Point(0, 500), Point(950, 500),
                       fern[2][1], // AffineData(0, 0, 0, 0.25, 0, -0.4, 0.02),
                       fern[2][2], // AffineData(0.95, 0.005, -0.005, 0.93, -0.002, 0.5, 0.84),
                       fern[2][3], // AffineData(0.035, -0.2, 0.16, 0.04, -0.09, 0.02, 0.07),
                       fern[2][4], // AffineData(-0.04, 0.2, 0.16, 0.04, 0.083, 0.12, 0.07),
                       0.7,
                       200000);

  Caption := 'o[Y[̃V_\Ă܂B: 631 ~ 551 Pixels';
end;

procedure TFrameForm.Button9Click(Sender: TObject);
begin
  Mandelbrot1.MAutoSize := True;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 0.007; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-2.09, 2.1, 2.11, -2.1);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := True;
  Mandelbrot1.JCC := RealPoint(-0.6, -0.5);
  Mandelbrot1.MCount := 256;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button10Click(Sender: TObject);
begin
  Mandelbrot1.FractalInit(631, 551, 2, clRed, clWhite);
  Caption := 'vZłB΂炭҂B';

  Mandelbrot1.Dragon(Point(110, 400), Point(400, 400), False, False, 14);

  Mandelbrot1.Canvas.Pen.Color := clFuchsia;
  Mandelbrot1.LevyC(Point(570, 110), Point(570, 310), 7, 11);

  Caption := 'hSȐƃBbȐ\Ă܂B: 631 ~ 551 Pixels';
end;

procedure TFrameForm.Button11Click(Sender: TObject);
begin
  Mandelbrot1.MAutoSize := True;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 0.00175; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-0.352344191771034, 0.681581565186326,
                                0.697655808228966, -0.368418434813674);
  Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := False;
  Mandelbrot1.BackColor := 255;
  Mandelbrot1.Julia := True;
  Mandelbrot1.JCC := RealPoint(-0.159, -0.655);
  Mandelbrot1.MCount := 512;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
end;

procedure TFrameForm.Button12Click(Sender: TObject);
begin
  Mandelbrot1.MAutoSize := True;
  Mandelbrot1.SizeOption := False;
  Mandelbrot1.Ruler := CheckBox1.Checked;
  Mandelbrot1.MStep := 0.002; OldStep := Mandelbrot1.MStep;
  Mandelbrot1.MRect := RealRect(-0.59, 0.6, 0.61, -0.6);
  UpDown1.Position := 255; Mandelbrot1.ColorOffset := UpDown1.Position;
  Mandelbrot1.ReversColor := False;
  Mandelbrot1.Monochrome := True;
  Mandelbrot1.BackColor := 249;
  Mandelbrot1.Julia := True;
  Mandelbrot1.JCC := RealPoint(-0.159, -0.655);
  Mandelbrot1.MCount := 330;
  Caption := 'vZłB΂炭҂B';
  Mandelbrot1.MExecute;
  UpDown1.Position := 0; // ƂɂǂĂ
end;

end.
